#include "nxm_head.h"
#define SHMKEY ((key_t) 7890)
#define SEKEY1 ((key_t) 7891)
#define SHMSIZE 1024
#define PERMS 0666
static struct sembuf    op_op[1] =
{
        0,-1,SEM_UNDO
};

int shmid=0,sem=0;
char *ttyn=NULL;
pid_t *pid_term;

quit_term()
{
#ifdef DEBUG
	printf("Quit\n");
#endif

	if(ttyn != NULL && shmdt(ttyn) < 0)
	{
		perror("shmdt:");
		exit(1);
	}
	exit(0);
}

	
main(argc,argv)
int argc;
char *argv[];
{
	int num;
	char *ttyn1;
	char buf[128];
	signal(SIGHUP,SIG_IGN);
	signal(SIGINT,quit_term);
	signal(SIGTERM,quit_term);
	signal(SIGSEGV,quit_term);

	if(argc == 2)
	{
		num=atoi(argv[1]);
	}else
	{
		num=0;
	}

	if((shmid=shmget(SHMKEY+num,SHMSIZE+sizeof(pid_t),0)) <0)
	{
		perror("shmget:");
		quit_term();
	}
	if((ttyn= (char *)shmat(shmid,(char *)0,0)) == (char *)-1)
	{
		perror("shmat:");
		quit_term();
	}
	if((sem=semget(SEKEY1+num,1,0)) < 0)
	{
		perror("semget");
		quit_term();
	}
	if((ttyn1=ttyname(0)) ==NULL)
	{
		perror("ttyname:");
		ttyn[0]=0;
		semop(sem, &op_op[0], 1);
		quit_term();
	}
	strncpy(ttyn,ttyn1,128);
	if(strlen(ttyn) < SHMSIZE)
	{
		pid_term = (pid_t *)(ttyn + SHMSIZE);
		(*pid_term) = getpid();
	}else
	{
		printf("error in ttyn");
		ttyn[0]=0;
		semop(sem, &op_op[0], 1);
		quit_term();
	}


	if (semop(sem, &op_op[0], 1) < 0)
	{
		perror("semop");
		quit_term();
	}

	while(1)
	{
		pause();
	}
	quit_term();
}
