#include "nxm_head.h"
#include "pcap.h"
#include "nxm_defines_v0.6b.h"
#include "nxm_external_v0.6b.h"

static struct sembuf op_wait[1]=
{
        0,0,0
};


extern int curses_fullscreen,current_mode;
extern int errno;


com_purge_slider_set(value)
int value;
{
	purge_time=value;
}


com_log_current(value)
int value;
{
	char *buf;
	char title[256];
	time_t clock;
	char tbuf[80];
	char *x;

	if (current==NULL || reachedEOF)
	{
		set_fi_value("Dead Session--can't log",0);
		set_lc_value(0);
    		return;
	}
	if (value==0 && current->curlog>0)
	{
		if (current->curlog==2)
		{
			time(&clock);
			sprintf(tbuf,"\n*** END AT: %s", ctime(&clock));
			write(current->logfd, tbuf, strlen(tbuf));
			close(current->logfd);
		}
		current->logfd=-1;
		current->curlog=-current->curlog;
		set_fi_value(current->logfile, 0);
	}
	if (value==1)
	{
   		/* current->log must be <= 0) */
   		if (current->curlog==-1)
		{
	    		if (raw_log>0)
			{
				current->curlog=1;
       				current->logfd=raw_log;
				strncpy(current->logfile, rawlog_filename,60);
				set_fi_value(rawlog_filename, 1);
   				return;
    			}else
			{
   				buf=(char *)get_filename2();
   				if ((raw_log=open(buf, O_WRONLY|O_CREAT|O_EXCL, 0600))<0)
				{
            				perror("open raw");
					set_lc_value(0);
            				return;
   				}else
				{
            				reachedEOF = 0;
					playspeed = 1;
					paused=0;
            				current->curlog=1;
            				current->logfd=raw_log;
            				strncpy(current->logfile, buf,60);
					strncpy(rawlog_filename, buf,60);
            				return;
   				}
 			}
		}
    		if (current->curlog==-2)
		{
	    		buf=(char *)get_filename2();
			for (x=buf;*x!=0;x++)
			if (!(isalnum(*x) || ispunct(*x)))
			{
				set_fi_value("Bad Filename", 0);
				set_lc_value(0);
				return;
			}
			if ((current->logfd=open(buf, O_WRONLY|O_CREAT|O_APPEND, 0600))<0)
			{
				set_fi_value("Bad Filename",0);
				set_lc_value(0);
   				return;
    			}
    			strncpy(current->logfile, buf,60);
			time(&clock);
			sprintf(title, "%s \n*** %s\n",
			current->pconrow->name,ctime(&clock));
    			write(current->logfd, title, strlen(title));
    			current->curlog=2;
			set_fi_value(current->logfile, 1);
    			return;
    		}
    		/* If we're here, something is bad! */
    		fprintf(stderr,"nasty error in on/off switch for logging!\n");
 	} 
	return;
}


com_ss_choice(value)
int value;
{
	struct tm *tm;
	char nbuf[80];
	time_t clock;

	if (current==NULL) return; /* Someone tried to log a dead connection */
	if (value==0 && current->curlog!=1)
	{
		if (current_input==0)
		{
		/* Then we're reading from a rawlog file... Don't allow rawlogs */
			set_ra_value(1);
			set_fi_value("Can't log rawlog input to a rawlog", 0);
			return;
		}
		if (current->logfd>0)
		{
			if (current->curlog==2)
			{
				time(&clock);
				sprintf(nbuf,"\n*** END AT: %s", ctime(&clock));
				write(current->logfd, nbuf, strlen(nbuf));
			}
			close(current->logfd);
			current->logfd=-1;
		}
		set_lc_value(0);
		current->curlog=-1;
		if (raw_log>0)
		{
			set_fi_value(rawlog_filename, 1);
    			return; /* if rawlog open, don't open another */
		}
		tm = localtime(&gtime);
		strftime(rawlog_filename, 60, "rawlog.%y%m%d%H%M", tm);
		set_fi_value(rawlog_filename, 1);
	}
	if (value==1 && current->curlog!=2)
	{
		set_lc_value(0);
		current->curlog=-2;
		set_fi_value("", 0);
	}
	return;
}

void com_clean_subtree_row(nrl)
struct con_row *nrl;
{
	struct con_row *nrlp;
	while (nrl)
	{
		nrlp=nrl->next;
		free((char *)nrl);
		nrl=nrlp;
	}
	return;
}

void com_clean_subtree(cp)
struct con *cp;
{
	struct con *cpp;
	char buf[80];
	time_t clock;

	while (cp)
	{
		cpp=cp->next;
		if ((cp->curlog==2 || cp->log==2 || cp->log==4) && cp->logfd>0)
		{

			time(&clock);
			sprintf(buf,"\n*** END AT: %s", ctime(&clock));
			write(cp->logfd, buf, strlen(buf));
			close(cp->logfd);
		}
		if(cp->plogl != NULL)
		{
			delete_loglog(cp->plogl);
			cp->plogl=NULL;
		}
		free((char *)cp);
		cp=cpp;
	}
	return;
}


/* This function chooses the place to get packets from.. It should
 * init the proper filedescripter and close all the open, logging fd's,
 * and dev fds
 * if choose 1, get the filename from fi_item, and check to see
 * if it exists.. If not, send error message through error_item,
 * and set back to 2 (system) If setting to 2 from 1, reinit the
 * network.
 */
com_choose_input(value)
int value;
{
	char fbuf[120];
	int  i;
	extern int errno;
	struct con *cp;
	char rawbuf[80];

	/* choose file, already rdng from there */
	if (!value && !current_input) return;

	/* choose net, already rdng from there */
	if (value && current_input)   return;

	if (current_input)
	{  /* Reading from network */
  		strncpy(fbuf, (char *)get_filename(), 120);
		if (!strlen(fbuf) || access(fbuf, R_OK))
		{
			if (!strlen(fbuf))
			{
				strcpy(fbuf, "Must Enter a filename"); 
			} else
			{
				switch(errno)
				{
    					case    EACCES:
						strcpy(fbuf, "Permission denied");
						break;
    					case	EIO:
						strcpy(fbuf, "File IO error");
						break;
    					case	ELOOP:
						strcpy(fbuf, "Too many symlinks");
						break;
    					case    ENOENT:
						strcpy(fbuf, "File not found");
						break;
					case	ENAMETOOLONG:
						strcpy(fbuf, "Filename too long");
						break;
					case	ENOTDIR:
						strcpy(fbuf, "Invalid Pathname");
						break;
					default:
						strcpy(fbuf, "Can't stat()");
						break;
    				}
			}
			set_error_label(fbuf);
			set_input_item(1);
    			return;
		}
	}
	if (raw_log>0) close(raw_log);
	if (current_input)
	{
    		if ((watchfd=open(fbuf, O_RDONLY))==0)
		{
			perror("FATAL: open raw--after checks");
			com_quit();
		}
	} else
		close(watchfd); 
	for (i=0;i<HASHSIZE;i++)
	{
		cp=con_hash[i];
		(void)com_clean_subtree(cp);
		con_hash[i]=NULL;
	}
	delete_all_rows();
	(void)com_clean_subtree_row(row_list);
	row_list=NULL;
	if (mapped)
	{
		select_row(-1);
		reset_mapping();
		mapped=0;
		cspos=0;
		current=NULL;
	}
	set_error_label("");
	if (current_input)
	{ /* reading from system */
		watched_rawlog=1;
		current_input=0;
		/*show_hosebutton(0);*/
		reachedEOF=0;
		playspeed=1;
		paused=0;
		ptime=0;
		delta_time=0;
		pkt_time=0;
	} else
	{
		current_input=1;
		/*show_hosebutton(1);*/
		time(&gtime);
	}
}

com_which_choice(op, string, choice)
int op;
char *string;
int choice;
{
	int i;
	if (op)
	{
		if(mapped)
		{
			reset_mapping();
			cspos=0;
			mapped=0;
			current=NULL;
		}
		if (playspeed>1) playspeed=1; /* Reset playback rate */
		if ((int)choice!=1)
		current=(struct con *)choice;
		else
		{
			fprintf(stderr,"Can't find info on that connection!!! (internal)\n");
			return;
		}
		create_login_windows();
	}
}

com_which_choice2(op, string, choice)
int op;
char *string;
int choice;
{
	int i,nonblock;
	struct termios tio;
	int pid;
	struct con * pcon;
	struct log_log *plogl;
	if (op)
	{
		if (playspeed>1) playspeed=1; /* Reset playback rate */
		if ((int)choice!=1)
		pcon=(struct con *)choice;
		else
		{
			fprintf(stderr,"Can't find info on that connection!!! (internal)\n");
			return;
		}
		if(pcon->plogl != NULL)
		{
			set_error_label("Already shown");
			return;
		}
		if(numlog >= LOG_MAX)
		{
			set_error_label("Should monitor less than %d
				conn\n",LOG_MAX);
			return;
		}
		if((pid=fork()) <0)
		{
			perror("fork");
			return;
		}else if (pid == 0)
		{
			char command[1024];
			sprintf(command,"%s -T \"%s\" -e %s %d",
				TERM,pcon->pconrow->name,
				TERM_PROGRAM,keyadd);
			if(execl("/bin/sh","sh","-c",command,NULL) < 0)
			{
				perror("execl");
				exit(0);
			}
		}else
		{
			int fd;
			int value;
			int count_of_failure=0;
			union semun semctl_arg;
			while(semop(sem,&op_wait[0],1) < 0)
			{
				if(errno == EINTR) continue;
				else
				{
					perror("semop");
					com_quit();
				}
			}
			semctl_arg.val = 1;
			if (semctl(sem, 0, SETVAL, semctl_arg) < 0)
			{
				perror("semctl");
				com_quit();
			}

#ifdef DEBUG
			printf("%s\n",swapspace);
#endif
			if((fd=open(swapspace, O_RDWR)) <0)
			{
				perror("open");
				return;
			}
			if((plogl = (struct log_log *)
				malloc(sizeof(struct log_log))) == NULL)
			{
				perror("malloc");
				return;
			}
			plogl->pcon = pcon;
			plogl->next = NULL;
			plogl->ttyfd = fd;
			FD_SET(fd,&allset);
			if(loghead == NULL) loghead=plogl;
			else
			{
				struct log_log *prev=loghead;
				while(prev->next != NULL) prev=prev->next;
				prev->next = plogl;
			}
			if(fd > maxfd) maxfd=fd;
			plogl->pid_term = (*pid_term);
			pcon->plogl=plogl;

#ifdef DEBUG
			printf("%d\n",plogl->pid_term);
#endif
			/* Perhaps here should set some TERM value wait!*/
			nonblock=1;
			fcntl(plogl->ttyfd,F_SETFL, O_NONBLOCK);
			if (tcgetattr(plogl->ttyfd, &tio)==0)
			{
				tio.c_lflag &= ~(ICANON | ISIG | ECHO | ECHOE | ECHOK | ECHONL);
				/* cbreak, pass signals, turn off all echoing */
				tio.c_oflag |= (OPOST | ONLCR);
				tio.c_cc[VMIN] = 1; /* Get 1 character */
				tio.c_cc[VTIME] = 0; /* No timeout */
				if (tcsetattr(plogl->ttyfd, TCSANOW, &tio)<0)
				perror("Can't set display terminal to CBREAK mode");
			} else
				perror("Can't get terminal characteristics");

			/* process the ttyfd , semaphore to sync */
		}
		numlog ++;
	}
}

com_quit()
{
	int i,loop;
	struct pcap_stat stat;
	void com_clean_subtree();
	struct con *cp;

	if (watchfd > 0) close(watchfd);
	if (ttyfd >= 0) close(ttyfd);

#ifdef DEBUG
	fclose(debug_dev);
#endif

#ifdef ICMP_PROCESS
	fclose(logicmp);
#endif

	for (i=0;i<HASHSIZE;i++)
	{
		cp=con_hash[i];
		com_clean_subtree(cp);
	}
	if (xv && row_list != NULL)
	{
		delete_all_rows();
		com_clean_subtree_row(row_list);
		row_list=NULL;
	}
	if(xv == 1) kill_frame();

	if(swapspace != NULL && shmdt(swapspace) < 0) perror("shmdt:");
	if(shmid > 0 && shmctl(shmid, IPC_RMID, (struct shmid_ds *)0) < 0)
		perror("shmctl:");
	if(sem > 0 && semctl(sem, 0, IPC_RMID, 0) < 0)
		perror("semclt");
	if(logcon != NULL) fclose(logcon);

	if (dev_desc != NULL && pcap_file(dev_desc) == NULL)
	{
		(void)fflush(stdout);
		putc('\n', stderr);
		if (pcap_stats(dev_desc, &stat) < 0)
		(void)fprintf(stderr, "pcap_stats: %s\n",pcap_geterr(dev_desc));
		else
		{
			(void)fprintf(stderr, "%d packets received by filter\n",
				stat.ps_recv);
			(void)fprintf(stderr, "%d packets dropped by kernel\n",
				stat.ps_drop);
		}
	}
	if(dev_desc != NULL) pcap_close(dev_desc);
	exit(0);
}

void write_cs(buf,x)
char *buf;
int x;

{
	int y;
	static int ticks=0;
	static char csbuf[256];
	int i;

	if (x<=0) return;
	ticks+=x;
	for (y=0;y<x;y++)
	if (((u_char)*(buf+y)<32 || (u_char)*(buf+y)>126))
			/*&& (u_char)*(buf+y) != 8
			&& (u_char)*(buf+y) != 9 )*/
		*(buf+y)='~';
	if ((y=(cspos+x))>79)
	{ /* if it will overrun text line */
		if (x>79)
		{ /* if new data will overrun line by itself */
			if (xv)
			{
				textcs_erase(0, -1);
				textcs_insert(buf+(x-79), 79);
			}
			memcpy(csbuf, buf+(x-79), 79);
			cspos=79;
		} else
		{

#ifdef SOLARIS
#define COLUMN 79
#else
#define COLUMN 80
#endif

			if (xv)
			{
				textcs_erase(0, (y-COLUMN));
				textcs_insert(buf, x);
			}
			/* Need to make sure we put the byte in the right place,
					   the first time through */
			for (i=0;i<COLUMN-(y-COLUMN);i++)
				csbuf[i]=csbuf[i+(y-COLUMN)];
			if (y==COLUMN)
				memcpy(&csbuf[i-1],buf,x); 
			else
			{
				memcpy(&csbuf[i], buf, x);
			}
			cspos=COLUMN;
		}
	} else
	{
		if (xv)
			textcs_insert(buf, x);
		memcpy(&csbuf[cspos], buf, x);
		cspos+=x;
	}
	if (xv)
	{
		if (ticks & 256)
		{ /* 16k? */
			ticks=0;
			textcs_reset();
			textcs_insert(csbuf, cspos);
		}
	} else
		redo_cswin(csbuf, cspos);
	return;
}


void write_sc(buf,x, log)
char *buf;
int x;
int log;

{
	char *nbuf;
	int x2;
	int y;

	if (x <= 0) return;

	if (xv)
		textsc_insert(buf, x);
	else
	{
		if (curses_fullscreen==0)
		{
			nbuf=(char *)malloc(x);
			x2=0;
			for (y=0;y<x;y++)
			if (((u_char)*(buf+y)>31 && (u_char)*(buf+y)<127)
					|| (u_char)*(buf+y)==10
					|| (u_char)*(buf+y)==8
					|| (u_char)*(buf+y)==9)
			{
				*(nbuf+x2)=*(buf+y);
				x2++;
			}
			redo_scwin(nbuf, x2);
			free(nbuf);
		} else 
			redo_scwin(buf, x);
	}
	/* I have processed it in main.c */
	/*if (current->curlog==2 && log)
		write(current->logfd, buf, x);*/
	return;
}

void dump_bufs(conn)
struct con *conn;
{
	 /* Try clearing the screen */
	if (xv) 
		write_sc("\033[0;0H\033[2J", 10, 0,0);
	if (conn->scbegin<conn->scend)
		write_sc(conn->scbuf+conn->scbegin, conn->scend-conn->scbegin, 0);
	if (conn->scend<conn->scbegin)
	{
		write_sc(conn->scbuf+conn->scbegin, 2048-conn->scbegin, 0);
		write_sc(conn->scbuf, conn->scend, 0);
	}
	if (conn->csbegin<conn->csend)
		write_cs(conn->csbuf+conn->csbegin, conn->csend-conn->csbegin);
	if (conn->csend<conn->csbegin)
	{
		write_cs(conn->csbuf+conn->csbegin, 80-conn->csbegin);
		write_cs(conn->csbuf, conn->csend);
	}
	conn->bytes_sent=0;
	return;
}

void redo_titles()
{
	struct con_row *nrl;
	int i;
	char new_title[80];
	int x, y;

	for (nrl=row_list,i=0;nrl!=NULL;i++,nrl=nrl->next)
	{
		if (current!=nrl->pcon)
		{
			x=(nrl->pcon)->bytes_sent;
			y=(nrl->pcon)->last_bytes_sent;
			if (x-y>50 || x-y<-50)
			{	/* Don't update unless more than
				 * a line of data came through */
				sprintf(new_title,"%-34s  %5d", nrl->name, x);
				if (xv)
					set_row_title(i, new_title);
				else
					curses_redo_row(i, new_title);
				(nrl->pcon)->last_bytes_sent=
					(nrl->pcon)->bytes_sent;
			}
		}
	}
	return;
}

com_pause_playback()
{
	if (current)
	{
		if (paused)
		{
			paused = 0;
			set_status_label("     ALIVE","green");
		} else
		{
			paused = 1;
			playspeed = 1;
			set_status_label("   * PAUSED *", "blue");
		}
	}
}

com_FF_playback()
{

	if (current)
	{
		if (paused) paused = 0;
		switch (playspeed)
		{
			case 1:
				playspeed = 2;
				set_status_label("     *X2*", "blue");
   				break;
			case 2:
				playspeed = 3;
				set_status_label("     *X3*", "blue");
				break;
			default:
				playspeed = 1;
				set_status_label("     ALIVE","green");
		}
	}
}

/* End all connections */
/* These four functions is very technical, so I left them to study more */
/* For more infromations ,please see common.c #577 */
com_hose()
{
}

/* send RST to current's server */
com_sendrst()
{
}

/* Send packet to current's client */
com_climessage()
{
}

/* Send packet to client or server */
send_packet()
{
}

void delete_loglog(struct log_log *plog)
{
	struct log_log *prevlog;
	if(plog == NULL) return;
	if(loghead == NULL)
	{
#ifdef DEBUG
		printf("Error,loghead is NULL\n");
#endif
		return;
	}

	close(plog->ttyfd);
	FD_CLR(plog->ttyfd,&allset);
	kill(plog->pid_term,SIGTERM);
	numlog --;

	if(plog == loghead)
	{
		loghead = loghead->next;
		free(plog);
	}else
	{
		prevlog=loghead;
		while(prevlog->next != NULL && prevlog->next != plog)
		{
			prevlog=prevlog->next;
		}
		if(prevlog->next == plog)
		{
			prevlog->next = plog->next;
			free(plog);
		}else
		{
#ifdef DEBUG
			printf("Error, no such log \n");
#endif
		}
	}
}

